#include "slidescale.h"

//////////////////////////////////////////////////////////////////////
// CSLIDEScale Class
//

CSLIDEScale::CSLIDEScale()
{
  m_vScale.Set(1.0, 1.0, 1.0);
}

CSLIDEScale::~CSLIDEScale()
{
}

VOID CSLIDEScale::Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		       DynVector *pdynv)
{
  ASSERT( pdynv != NULL );

  CSLIDETransform::Init(pcFile, uiLine, uiColumn);

  m_vScale.SetAll(pdynv);
}

VOID CSLIDEScale::Uninit()
{
  CSLIDETransform::Uninit();
}

BOOL CSLIDEScale::Initialized()
{
  return CSLIDETransform::Initialized();
}

BOOL CSLIDEScale::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  if ( !CSLIDETransform::CheckSemantics(pCSLIDEWorld) )
    {
      return FALSE;
    }

  return TRUE;
}

BOOL CSLIDEScale::Valid()
{
  if ( !CSLIDETransform::Valid() )
    {
      return FALSE;
    }

  return TRUE;
}

////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 3: Fill these in
// 
VOID CSLIDEScale::CheckDynamic()
{
}

VOID CSLIDEScale::UpdateState()
{
  m_vScale.Update();
  // Set the transform matrix and its inverse
}
// 
// END  : ASSIGNMENT 3: Fill these in
////////////////////////////////////////////////////////////////////////

VOID CSLIDEScale::WriteSLIDE(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "    %s ( %.3f %.3f %.3f )\n", 
	  gcppcSLIDEReservedWords[sliderwtScale],
	  m_vScale[X], m_vScale[Y], m_vScale[Z]);
}
